>From d4c48c132bc6e0fee5812ceeb71b546508142b96 Mon Sep 17 00:00:00 2001
From: Dominique Leuenberger <dominique@messiah.leuenberger.net>
Date: Thu, 5 Jun 2008 23:05:37 +0300
Subject: [PATCH] Link libaccess_http_plugin against libproxy to autoconfigure proxy from the system.
 libproxy knows how to treat envvar (http_proxy), gnome settings and kde settings.

---
 modules/access/http.c |   22 +++++++++++++++++++++-
 1 files changed, 21 insertions(+), 1 deletions(-)

diff --git a/modules/access/http.c b/modules/access/http.c
index 8a04e14..c2eb686 100644
--- a/modules/access/http.c
+++ b/modules/access/http.c
@@ -52,6 +52,7 @@
 
 #include <assert.h>
 
+#include "proxy.h"
 /*****************************************************************************
  * Module descriptor
  *****************************************************************************/
@@ -306,7 +307,26 @@ static int OpenWithCookies( vlc_object_t *p_this, vlc_array_t *cookies )
         p_sys->b_proxy = true;
         vlc_UrlParse( &p_sys->proxy, psz, 0 );
     }
-#ifdef HAVE_GETENV
+#ifdef PROXY_H_
+    else
+    {
+	pxProxyFactory *pf = px_proxy_factory_new();
+        if (!pf)
+        {
+		msg_Warn(p_access, "Loading of libproxy failed");
+                return 1;
+        }
+	char *buf ; sprintf(buf, "%s://%s", p_access->psz_access, p_access->psz_path);
+	msg_Warn(p_access, "asking libproxy about url '%s'", buf);
+	char **proxies = px_proxy_factory_get_proxies(pf, buf);
+	if (proxies[0]) 
+	{
+	    msg_Warn(p_access, "libproxy suggest to use '%s'", proxies[0]);
+	    p_sys->b_proxy = true;
+	    vlc_UrlParse( &p_sys->proxy, proxies[0], 0);
+	}
+    }
+#elif HAVE_GETENV
     else
     {
         char *psz_proxy = getenv( "http_proxy" );
-- 
1.5.4.5

